<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="场馆名称" label-width="70px">
        <el-input
          v-model="queryParams.theatreName"
          placeholder="请输入场馆名称"
          clearable
          style="width: 240px;"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="剧目名称">
        <el-input
          v-model="queryParams.performName"
          placeholder="请输入剧目名称"
          clearable
          style="width: 240px;"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="选择日期">
        <el-date-picker
          v-model="queryParams.performDate"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="状态">
        <el-select
            v-model="queryParams.status"
            placeholder="状态"
            clearable
            style="width: 100%"
            @change="handleQuery"
          >
            <el-option
              v-for="dict in statusList"
              :key="dict.id"
              :label="dict.name"
              :value="dict.value"
            />
          </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
              type="success"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd(null)"
              v-hasPermi="['schedulingMr:schedulingMr:add']"
            >添加</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd('batch')"
          v-hasPermi="['schedulingMr:schedulingMr:batch']"
        >批量添加</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          @click="handleBatchDelete"
          v-hasPermi="['schedulingMr:schedulingMr:batchDelete']"
        >批量删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table ref="tables" v-loading="loading" :data="dataList" border @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="50" align="center" />
      <el-table-column label="序号" align="center" type="index" width="50"></el-table-column>
      <el-table-column label="场馆名称" align="center" prop="theatreName" />
      <el-table-column label="演出厅" align="center" prop="auditoriumName" />
      <el-table-column label="剧目名称" align="center" prop="performName" />
      <el-table-column label="票务名称" align="center">
        <template slot-scope="scope">
          <span>
            {{ scope.row.goodsNames  }}
          </span>
        </template>
      </el-table-column>
      <el-table-column label="日期" align="center" prop="performDate" />
      <el-table-column label="开始时间" align="center" prop="performTimeStart" width="160">
        <template slot-scope="scope">
          <span>{{ scope.row.performTimeStart }}</span>
        </template>
      </el-table-column>
      <el-table-column label="结束时间" align="center" prop="performTimeEnd" width="160">
        <template slot-scope="scope">
          <span>{{ scope.row.performTimeEnd }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="status">
        <template slot-scope="scope">
          <el-tag type="success" v-if="scope.row.status == '1'">启用</el-tag>
          <el-tag type="danger" v-else-if="scope.row.status == '2'">禁用</el-tag>
          <!-- <el-tag type="info" v-else>待发布</el-tag> -->
          <!-- <span>{{ scope.row.status }}</span> -->
          <!-- <dict-tag :options="statusList" :value="String( scope.row.status)"/> -->
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            @click="ionlineApi(scope.row)"
            v-hasPermi="['schedulingMr:schedulingMr:edit']"
          >{{scope.row.status == '1' ? '禁用' : '启用'}}</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['schedulingMr:schedulingMr:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleDelete(scope.row,scope.index)"
            v-hasPermi="['schedulingMr:schedulingMr:delete']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 新增/编辑弹框 -->
    <add-and-edit
      ref="addAndEdit"
      :dict="dict"
      @getList="getList"
    />


    <el-dialog
      title="查看"
      :visible.sync="visibleStatus"
      width="600px"
      :destroy-on-close="true"
      :close-on-click-modal="false"
    >
      <div v-if="visibleType == 'img'">
        <el-image
          style="width: 400px; height: 100%"
          :src="newObj.mainImg"
          fit="cover"
        />
      </div>
      <div v-if="visibleType == 'html'">
        <div v-html="newObj.centent"></div>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="visibleStatus = false">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>

import { pageList, deleteById, deleteBatchById,ionline } from '@/api/schedulingMr/schedulingMr'
import addAndEdit from "./dialog/addAndEdit";

export default {
  name: "SchedulingMr1",
  dicts: ['agreement_type'],
  components: { addAndEdit },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户表格数据
      dataList: null,
      // 弹出层标题
      title: "",

      // 是否显示弹出层
      open: false,
      // 日期范围
      dateRange: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        type: undefined,
      },
      statusList: [
        // {id: 1, name: '未发布', value: 0},
        {id: 1, name: '启用', value: 1},
        {id: 2, name: '禁用', value: 2},
      ],
      visibleStatus: false,
      newObj: {},
      visibleType: '',
    };
  },
  created() {
    this.getList();
  },
  // activated(){
  //   this.getList();
  // },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      pageList(this.addDateRange(this.queryParams, this.dateRange))
      .then(response => {
          this.dataList = response.data.rows;
          this.total = response.data.total;
          this.loading = false;
        }
      ).catch(() => {
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.$set(this.queryParams, 'theatreName', '');
      this.$set(this.queryParams, 'performDate', '');
      this.$set(this.queryParams, 'performName', '');
      this.$set(this.queryParams, 'status', '');
      this.queryParams.pageNum = 1;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
    },
    /** 新增按钮操作 */
    handleAdd(type) {
      this.$refs["addAndEdit"].openDialog("新增数据", null, type);
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$refs["addAndEdit"].openDialog("修改数据", row);
    },

    /** 发布或者取消发布按钮操作 */
    ionlineApi(row) {
      this.$confirm("是否对:" + row.performName + row.goodsNames + "的数据进行" + (row.status == 1 ? '禁用？' : '启用？'), '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.loading = true;
        ionline({ id: row.id, status: row.status == 1 ? 2 : 1 }).then((res) => {
          if (res.code == 200) {
            this.$message({
              type: 'success',
              message: '操作成功!'
            });
            this.getList();
          }
        });
      }).catch((error) => {
        this.$message({
              type: 'error',
              message: error.msg
            });
      }).finally(() => {
        this.loading = false;
      });
    },

    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除该数据？').then(function() {
        return deleteById(row.id);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },

    /** 批量删除按钮操作 */
    handleBatchDelete() {
      if(!this.ids || this.ids.length == 0){
        this.$modal.msgWarning("请选择需要删除的数据！");
        return false
      }
      this.$confirm('是否确认删除选中的数据?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteBatchById(this.ids.toString())
          .then(response => {
              this.getList();
              this.$modal.msgSuccess("删除成功");
          }).catch(() => {
        });
      }).catch(() => {});
    },

    /** 查看按钮操作 */
    seeCenter(obj, type) {
      this.visibleStatus = true
      this.visibleType = type;
      this.newObj = obj;
    }
  }
};
</script>
